$(document).ready(function () {

	if (localStorage.idUsuarios == "undefined" || localStorage.Empresa == "undefined") {
		window.location = "index.html";
	}

	setNITObjectText();

	$("#username").html(localStorage.nombreUsuario.toLowerCase());
	getCategorias();
	loadProductosVenta();
	getDocumentoFacturacion();
	$("#usuario").html(localStorage.nombreUsuario);
	aperturaCaja();

	$('#btn-enEspera').tooltip();
	$('#btn-recuperarEspera').tooltip();


	// if(localStorage.touchEnabled == "false"){
	//     $("#usuario").removeAttr('disabled');
	//     $("#password").removeAttr('disabled');
	//     $("input").focus();
	// }

	// $("#buscadorCategorias").hide();

	$("#tipoMoneda").val("1");
	$("#tipoMoneda").change(function () {
		if ($(this).is(":checked")) {
			//console.log("dolar")
			reloadMoneda(2);
		} else {
			reloadMoneda(1);
			//console.log("quetzal")
		}
	});

	$("#modalAutorizacion").modal({
		"inDuration": 0,
		"outDuration": 0
	});

	$("#modal1").modal();
	$('#modal1').modal({
		"dismissible": false,
		"inDuration": 0,
		"outDuration": 0
	});

	$('#modalCuenta').modal({
		"inDuration": 0,
		"outDuration": 0
	});

	$('#nit').on('keyup', function () {
		let actual = $('#nit').val();
		
		clearTimeout(timer);

		timer = setTimeout(function(){
			if(actual != ""){
				validarNIT();
			}
		}, waitTime);
	});
});

function reloadMoneda(idFormaPago) {
	$("#tipoMoneda").val(idFormaPago);
	$("#productos").empty();
	loadProductosVenta();

}

function getProductosCategorias(idCategorias) {
	$("#txtScanner").focus();
	// $("#buscadorGeneral").hide();
	// $("#buscadorCategorias").show();

	let llave = 0;
	//! Revisar si la empresa cuenta con precios por sucursal
	if (precioSucursal) {
		llave = 1;
	}

	params = {
		service: "getProductosCategorias",
		idCategorias: idCategorias,
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales,
		llave: llave
	};
	$.post(host, params, function (data) {
		$("#productos").html("");
		var component = ``;

		$.each(data, function (key, val) {
			var image = hostImages + val.image;

			let color = accounting.unformat(val.existencia) > 0 ? "light-green" : "deep-orange ";
			let icon = accounting.unformat(val.existencia) > 0 ? "check" : "clear";
			let showIcon = val.idTipoProductos == 3 ? false : true;
			let existencia = accounting.formatNumber(val.existencia, 3);
			//console.log(val);	
			productoVenta = `agregarProductoVenta(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',1, ${val.precioPublico},0,${val.precioPublico},${agruparProductos? 1 : 0});`;
			// productoVenta = `${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',1`;
			if (pVariable && val.precioPublico == 0) {
				// swalPrecioPublico();
				productoVenta = `swalPrecioPublico(${val.id
					},${accounting.unformat(val.existencia)},${val.idTipoProductos
					},'${val.descLarga}',1);`;
			} else {
				productoVenta = `agregarProductoVenta(${val.id
					},${accounting.unformat(val.existencia)},${val.idTipoProductos
					},'${val.descLarga}',1, ${val.precioPublico},0,${val.precioDolar},${agruparProductos? 1 : 0});`;
			}

			if (val.menuOpcion != "No tiene Opcion") {
				productoVenta = `opcionesProducto(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',${val.precioPublico})`;
			}
			
			if(val.idAvailableSale == 2){
				productoVenta ="";
			}

			let prodCardSize = "m3 s6";
			if(fullProdCard){
				prodCardSize = "m12 s12";
			}

			component += `<section><div class="col ${prodCardSize}">
				<div class="card shapedbox" onclick="${productoVenta}">`;

			if(val.idAvailableSale == 2){
				component += `<div style="background-color: #00000069;width: 100%;height: 100%;position: absolute;z-index: 2;top: 0px;" class="shapedbox"></div>`;
			}

			//console.log(localStorage.showImg)
			//Determina si se muestra imagen del producto
			if (localStorage.showImg == 'true') {
				component += `<p class="nombre-card">${val.descLarga.toLowerCase()}</p>
					<div class="card-image">
					<img src="${image}" class='responsive-img imgProducto center'>
				</div>
				<div class="card-content">
					<p class='truncate sku-card'>
						${val.sku}
					</p>`;
			} else {
				component += `<p class="nombre-card-sin-img">${val.descLarga.toLowerCase()}</p>
				<div class="card-content">
					<p class='truncate sku-card'>
						${val.sku}
					</p>`;
			}

			// ! Agregar una opcion para que muestre o no las existencias.
			if (showIcon) {
				if(verExistencias){
					// Este es el nuevo componente que muestra las existencias:
					component += `
								<div style="padding: 0.1rem; position: absolute; border-radius: 20px; line-height: 1.5rem;" class="${color}">
									<span style="font-size: small; margin: 0.5rem; color: white;">${existencia}</span>
								</div>`;
				}
				else{
					// Esta es la linea que no muestra existencias, solo un icono que indica si hay o no hay existencias en el inventario:
					component += `<a class="btn-existencias btn-floating btn-flat btn-small waves-effect waves-light ${color}"><i class="material-icons">${icon}</i></a>`;
				}
			}

			//component += `<div style="float: right;">${val.menuOpcion}</div></br>`;
			component += `<p class='precio-card accent-color'>`;
			if ($("#tipoMoneda").val() == "2") { //Si es Dolar:
				component += `$${val.precioDolar}`;
			} else {
				component += `Q${val.precioPublico}`;
			}
			component += `</p>
							</div>
						</div>
						</div></section>`;
		});
		$("#productos").html(component);

		if (!muestraIMGS) {
			$("img").each(function () {
				if (
					!this.complete ||
					typeof this.naturalWidth == "undefined" ||
					this.naturalWidth == 0
				) {
					// image was broken, replace with your new image
					this.style = "display:none";
					this.src = "assets/images/default.jpg";
				}
			});
		}
	},
		"json",
	);
}

// buscador por categorias
$("#buscadorCategorias").on("keyup", function () {
	//console.log("2")
	var value = $(this).val().toLowerCase();
	$("#productos section").filter(function () {
		$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
	});
});

// buscador general
// Optimizado con un delay para evitar que se anidaran las consultas.

// $("#buscadorGeneral").on("keyup", delay(function() {
// 	var input = $(this).val();
// 	if(input.length >= 3){
// 		console.log("1")
// 		getProductosBuscador(input);
// 	}
// }, 500));

$('#buscadorGeneral').keypress(function (event) {
	var input = $(this).val();
	var keycode = (event.keyCode ? event.keyCode : event.which);
	if (keycode == '13') {
		getProductosBuscador(input);
	}
});



// Delay para esperar a que se termine de teclear.
function delay(callback, ms) {
	var timer = 0;
	return function () {
		var context = this, args = arguments;
		clearTimeout(timer);
		timer = setTimeout(function () {
			callback.apply(context, args);
		}, ms || 0);
	};
}

/*
function buscador (type) {
	switch(type){
	case 'general':
	return <funcion general>
	case 'categoria':
	return <funcion categoria>
	default: break;
	}
}
*/


function getProductosBuscador(valorIngresado) {
	$("#txtScanner").focus();
	//console.log(valorIngresado.length)
	if ($("#buscadorGeneral").val() == "") {
		$("#productos").empty();
	} else {

		let llave = 0;
		//! Revisar si la empresa cuenta con precios por sucursal
		if (precioSucursal) {
			llave = 1;
		}

		params = {
			service: "getProductosBuscador",
			dbName: dbName,
			idEmpresas: localStorage.idEmpresas,
			idSucursales: localStorage.idSucursales,
			valorIngresado: valorIngresado,
			llave: llave
		};
		$.post(host, params, function (data) {
			$("#productos").empty();
			var component = ``;

			$.each(data, function (key, val) {
				var image = hostImages + val.image;

				let color = accounting.unformat(val.existencia) > 0 ? "light-green" : "deep-orange ";
				let icon = accounting.unformat(val.existencia) > 0 ? "check" : "clear";
				let showIcon = val.idTipoProductos == 3 ? false : true;
				let existencia = accounting.formatNumber(val.existencia, 3);

				productoVenta = `agregarProductoVenta(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',1, ${val.precioPublico},0,0,${agruparProductos? 1 : 0});`;
				// productoVenta = `${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',1`;
				if (pVariable && val.precioPublico == 0) {
					// swalPrecioPublico();
					productoVenta = `swalPrecioPublico(${val.id
						},${accounting.unformat(val.existencia)},${val.idTipoProductos
						},'${val.descLarga}',1);`;
				} else {
					productoVenta = `agregarProductoVenta(${val.id
						},${accounting.unformat(val.existencia)},${val.idTipoProductos
						},'${val.descLarga}',1, ${val.precioPublico},0,0,${agruparProductos? 1 : 0});`;
				}

				if (val.menuOpcion != "No tiene Opcion") {
					productoVenta = `opcionesProducto(${val.id},${accounting.unformat(val.existencia)},${val.idTipoProductos},'${val.descLarga}',${val.precioPublico})`;
				}

				if(val.idAvailableSale == 2){
					productoVenta = "";
				}
				
				let prodCardSize = "m3 s6";
				if(fullProdCard){
					prodCardSize = "m12 s12";
				}
				
				component += `<section><div class="col ${prodCardSize}">
					<div class="card shapedbox" onclick="${productoVenta}">`;

				if(val.idAvailableSale == 2){
					component += `<div style="background-color: #00000069;width: 100%;height: 100%;position: absolute;z-index: 2;top: 0px;" class="shapedbox"></div>`;
				}

				//console.log(localStorage.showImg)
				//Determina si se muestra imagen del producto
				if (localStorage.showImg == 'true') {
					component += `<p class="nombre-card">${val.descLarga.toLowerCase()}</p>
						<div class="card-image">
						<img src="${image}" class='responsive-img imgProducto center'>
					</div>
					<div class="card-content">
						<p class='truncate sku-card'>
							${val.codigoAlterno}
						</p>`;
				} else {
					component += `<p class="nombre-card-sin-img">${val.descLarga.toLowerCase()}</p>
					<div class="card-content">
						<p class='truncate sku-card'>
							${val.codigoAlterno}
						</p>`;
				}

				// ! Agregar una opcion para que muestre o no las existencias.
				if (showIcon) {
					if(verExistencias){
						// Este es el nuevo componente que muestra las existencias:
						component += `
						<div style="padding: 0.1rem; position: absolute; border-radius: 20px; line-height: 1.5rem;" class="${color}">
							<span style="font-size: small; margin: 0.5rem; color: white;">${existencia}</span>
						</div>`;
					}
					else{
						// Esta es la linea que no muestra existencias:
						component += `<a class="btn-existencias btn-floating btn-flat btn-small waves-effect waves-light ${color}"><i class="material-icons">${icon}</i></a>`;
					}
				}

				//component += `<div style="float: right;">${val.menuOpcion}</div></br>`;
				component += `<p class='precio-card accent-color'>`;
				if ($("#tipoMoneda").val() == "2") { //Si es Dolar:
					component += `$${val.precioDolar}`;
				} else {
					component += `Q${val.precioPublico}`;
				}
				component += `</p>
								</div>
							</div>
							</div></section>`;


			});
			$("#productos").html(component);

			if (!muestraIMGS) {
				$("img").each(function () {
					if (
						!this.complete ||
						typeof this.naturalWidth == "undefined" ||
						this.naturalWidth == 0
					) {
						// image was broken, replace with your new image
						this.style = "display:none";
						this.src = "assets/images/default.jpg";
					}
				});
			}
		},
			"json",
		);
	}
}

function drawCart(data) {
	var detail = "";
	var summary = "";
	var subtotalVenta = 0; //Valor total de la venta sin descuentos
	var total1 = 0;
	var total2 = 0;
	var totalDolar = 0;
	var subtotalDolar = 0;
	var totalDescontado = 0; //Valor total de los descuentos aplicados
	if (data === null) {
		$("#btn-recuperarEspera").attr('disabled', false);
		$("#btn-enEspera").attr('disabled', true);
		detail += "<li>";
		detail += '<div class="row detalleCarrito">';
		detail += '<div class="col s12 center-align">';
		detail += "0 registros encontrados en el carrito";
		detail += "</div>";
		detail += "</div>";
		detail += "</li>";

		$("#subtotalVenta").val(0);
		$("#total").val(0);
		$("#totalDescontado").val(0);
		$("#totalItems").val(0);
		//$("#spanTotal").html("Q " + accounting.formatNumber(0, 2));
		if ($("#tipoMoneda").val() == "2") { //Si es Dolar:
			$("#spanTotal").html("$ " + accounting.formatNumber(0, 2));
		} else {
			$("#spanTotal").html("Q " + accounting.formatNumber(0, 2));
		}

		$("#rowDescuento").hide();
		$("#rowSubTotal").hide();
	} else {
		$("#btn-enEspera").attr('disabled', false);
		$("#btn-recuperarEspera").attr('disabled', true);
		detail = "";
		$.each(data, function (key, val) {

			var Upc = "'" + val.Upc + "'";
			//var Precio = "'" + accounting.unformat(val.precio) + "'";
			subtotalVenta += accounting.unformat(val.subtotal);
			total1 += accounting.unformat(val.total);
			total2 += accounting.unformat(val.cantidad);

			subtotalDolar += accounting.unformat(val.totalDolares + val.descuento); //Cumple la funcion del subtotal sin descuentos
			totalDolar += accounting.unformat(val.totalDolares);

			totalDescontado += accounting.unformat(val.descuento);

			let precio = "";

			if ($("#tipoMoneda").val() == "2") { //Si es Dolar
				precio = accounting.formatMoney((val.totalDolares), "$ ", 2);
			} else {
				precio = accounting.formatMoney((val.subtotal - val.descuento), "Q ", 2);
			}

			//detail += `<li class="collection-item" onclick="eliminarProductoVenta(${val.id},'${val.descLarga}');">`;
			detail += `<li class="collection-item" onclick="menuOpciones(${val.id},'${val.descLarga}','${val.subtotal}','${val.cantidad}',${val.idProductos},${val.precioDolares});">`;
			detail += '<div class="row detalleCarrito">';
			detail +=
				'<div class="col s2 left-align" style="padding: 0px;">';
			detail += "<span>" + parseFloat(val.cantidad) + "x</span>";
			//detail += '<i class="mdi mdi-minus-circle red-text" onclick="quitarItemCarrito(' + Upc + ',' + accounting.formatNumber(val.cantidad, 0) + ',' + val.id + ');"></i>';
			detail += "</div>";
			detail +=
				'<div class="col s10 left-align truncate" style="padding: 0px;">' +
				val.descLarga.toLowerCase() +
				"</div>";
			if (val.SubOpciones != '0') {
				if (val.SubOpciones != undefined) {
					detail += `<label >${val.SubOpciones} </label>`;
				}
			}

			detail += '<div class="col s12 right-align">';
			if (val.descuento > 0) {
				detail += `<label style="color:#FF0000";>(-${accounting.formatNumber(val.descuento, 2)}) </label>`;
			}

			detail += precio;
			// if ($("#tipoMoneda").val() == "2"){ //Si es Dolar
			// 	detail += " $ " + accounting.formatNumber((val.totalDolares), 2); 
			// } else {
			// 	detail += " Q " + accounting.formatNumber((val.subtotal - val.descuento), 2);				
			// }

			//detail += '<i class="mdi mdi-plus-circle red-text" onclick="agregarItemCarrito(' + Upc + ', ' + Precio + ');"></i>';
			detail += "</div>";
			detail += "</div>";
			detail += "</li>";
		});
		// summary += '<li class="collection-item">';
		// summary += 'No. Productos:';
		// summary += `<span class="totales"><input type="hidden" id="totalItems" value="${total2}"/>${accounting.formatNumber(total2, 0)}</span>`;
		// summary += '</li>';
		// summary += '<li class="collection-item">';
		// summary += `<div class="row" style='margin-bottom:0px !important;'>`;
		// summary += `<div class="col s2 left-align" style='font-size:1.5em !important;'>Total:</div>`;
		// summary += `<div class="col s10 right-align"><span class="totales" style='font-size:1.5em !important;'><input type="hidden" id="total" value="${total1}"/>Q. ${accounting.formatNumber(total1, 2)}</span></div>`;
		// summary += `</div>`;
		// summary += '</li>';

		if ($("#tipoMoneda").val() == "2") {
			//$("#total").val(totalDolar); // aqui se transforma ya el total a la moneda que deberia guardar 

			$("#totalDolares").val(accounting.formatNumber(totalDolar, 2));
			$("#subtotalVenta").val(accounting.formatNumber(subtotalDolar, 2));
			$("#spanSubTotal").html(accounting.formatNumber(subtotalDolar, 2));
		} else {
			$("#total").val(accounting.formatNumber(total1, 2));
			$("#subtotalVenta").val(accounting.formatNumber(subtotalVenta, 2)); //Valor total de la venta sin descuentos
			$("#spanSubTotal").html("Q " + accounting.formatNumber(subtotalVenta, 2));
		}

		$("#totalDescontado").val(accounting.formatNumber(totalDescontado, 2)); //Valor total de los descuentos aplicados
		$("#spanDescontado").html("- Q " + accounting.formatNumber(totalDescontado, 2));
		
		if(totalDescontado > 0){
			$("#rowDescuento").show();
			$("#rowSubTotal").show();
		}
		else{
			$("#rowDescuento").hide();
			$("#rowSubTotal").hide();
		}

		$("#totalItems").val(total2);
		//$("#spanTotal").html("Q " + accounting.formatNumber(total1, 2));

		//$("#totalQuetzales").val(accounting.formatNumber(total1, 2));
		if ($("#tipoMoneda").val() == "2") { //Si es Dolar
			$("#spanTotal").html("$ " + accounting.formatNumber((totalDolar), 2));
		} else {
			$("#spanTotal").html("Q " + accounting.formatNumber(total1, 2));
		}
	}
	$("#detalleCarrito,#resumenCarrito").empty();
	$("#detalleCarrito").append(detail);
	$("#resumenCarrito").append(summary);
	resizeDOMHeights();
}

// ! Evaluar si se puede usar en global.js
function cleanPwrd() {
	$("#usuario").val("");
	$("#password").val("");
	('.keyPad').attr('onclick', 'insertNumPad(this,"TxtNumPad");');
}

function enEspera() {
	$("#loader").show();
	console.log("EN ESPERA");
	params = {
		service: "enEspera",
		dbName: dbName,
		idUsuarios: localStorage.idUsuarios
	};
	$.post(host, params, function (data) {
		console.log(data);

	}, "json",
	).done(function () {
		$("#loader").hide();
		loadProductosVenta();
	});
}

function getEspera() {
	console.log("RECUPERAR EN ESPERA");
	$("#loader").show();
	params = {
		service: "getEspera",
		dbName: dbName,
		idUsuarios: localStorage.idUsuarios
	};
	$.post(host, params, function (data) {
		console.log(data);

	}, "json",
	).done(function () {
		$("#loader").hide();
		loadProductosVenta();
	});
}

function consultarEspera() {
	//funcion para consultar si es que hay productos en carrito de espera
	params = {
		service: "consultaEspera",
		dbName: dbName,
		idUsuarios: localStorage.idUsuarios
	};
	$.post(host, params, function (data) {
		console.log(data);
		if (data === null) {
			console.log("no hay productos");
			enEspera();
		} else {
			Swal.fire({
				html: `<div>Existen productos en carrito de espera, &iquest;desea remplazarlos?</div>`,
				icon: 'question',
				cancelButtonText: "Cancelar",
				showCancelButton: true,
				confirmButtonColor: '#3085d6',
				confirmButtonText: 'Reemplazar',
			}).then((result) => {
				if (result.value) {
					enEspera();
				}
			});
			$.each(data, function (key, val) {
				console.log(val);
			});
		}

	}, "json",
	).done(function () {
		$("#loader").hide();
	});

}