$(document).ready(function () {
	aperturaCaja();
	getProductoSelect();
	//getServicioSelect();
	getCarrito();
	getTotalesCarrito();
	getDocumentoFacturacion();
	getDocumentoRecibo();
	getVendedores();
	//Inicializacion formatos para imprimir
	getHeaderFactura();
	//Ajustar altura de elementos del DOM
	resizeDOMHeights();
	//encabezadoEmpresa();
	//getTransportistas();
	//getHeaderEnvio();
	//getHeaderEnvioRecibo();
	//getPrimerMes();
	setNITObjectText();

	if (printFactura) {
		$("#imprimirFactura").prop("checked", false);
	}

	if (devoluciones) {
		$("#regaloDiv").show();
	} else {
		$("#regaloDiv").hide();
	}

	$('#modal1').modal();

});

function delay(callback, ms) {
	var timer = 0;
	return function () {
		var context = this, args = arguments;
		clearTimeout(timer);
		timer = setTimeout(function () {
			callback.apply(context, args);
		}, ms || 0);
	};
}

function encabezadoEmpresa() {
	$("#headerEmpresa").html("");
	params = {
		service: "empresaActual",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
	};
	$.post(host, params, function (data) {
		let empresaNombre = "";
		$.each(data, function (key, val) {
			empresaNombre += `<h5 style="margin-top: 10px;font-weight: bold;cursor:pointer;" onclick="cambiarEmpresa()">Empresa: ${val.nombreComercial}</h5>`;
		});
		$("#headerEmpresa").html(empresaNombre);
	}, "json");
}

/*
function cambiarEmpresa(){
	Swal.fire({
		title: `Seleccione una Empresa`,   
		html: `<div class="row">
			<select class="browser-default" id="selectEmpresas" style="border-top-width: 10px;font-size: small;border: 1px solid white;border-bottom-color: #545454;"></select>
			<div style="color:red;">* Considere que perdera los articulos del carrito *</div>
			</div>`,
		showConfirmButton: true,
		showCancelButton: true,
		confirmButtonColor: '#ff8f00',
		cancelButtonText: "Cancelar",
		confirmButtonText: "Cambiar Empresa",
		onOpen() {
			getEmpresas();
			//Funcion para obtener las opciones de las empresas en el select
		},
		customClass: {
			container: 'my-swal'
		}	
	}).then((result) => {
		if (result.isConfirmed) {
			if($("#selectEmpresas").val() != ""){
			//Cambiar el localStorage idEmpresas
			localStorage.idEmpresas = $("#selectEmpresas").val();
			location.reload();
			}else{
				Swal.fire({
					icon: "warning",
					text: "Seleccione una Empresa",
					showCloseButton: true,
					confirmButtonText: "Intentar de nuevo",
					confirmButtonColor: "#3085d6",
				}).then((result) => {});
			}
		}		
	});
}

function getEmpresas(){
	params = {
		service: "getEmpresas",
		dbName: dbName
	};
	$.post(host, params, function (data) {
		let empresas = `<option value="">Seleccione una Empresa...</option>`;
		$.each(data, function (key, val) {
			empresas += `<option value="${val.id}"> ${val.nombreComercial}</option>`;
		});
		$("#selectEmpresas").html(empresas);
	}, "json").done(function(){

	});
}
*/


$("#codCliente").on("click", function () {
	if ($("#totalItems").val() >= 1) {
		Swal.fire({
			html: "Si cambia de cliente, se eliminaran los productos del carrito.",
			icon: "warning",
			showCancelButton: false,
			confirmButtonColor: "#3085d6",
			cancelButtonColor: "#d33",
			confirmButtonText: "Aceptar",
			allowOutsideClick: false
		}).then((result) => {
			$("#codCliente").on("keyup", delay(function () {
				var valor = $(this).val();
				if (valor != "") {
					getClientesSelect(valor);
				}
				cambioCliente("codCliente");
			}, 1000));
		});
	} else {
		$("#codCliente").on("keyup", delay(function () {
			var valor = $(this).val();
			if (valor != "") {
				getClientesSelect(valor);
			}
			cambioCliente("codCliente");
			//consultaCliente($("#selectClientes").val());
		}, 1000));
	}
});
/*
$("#nitFactura").on("click", function() {
	if($("#totalItems").val() >= 1){
		Swal.fire({
			html: "Si cambia de cliente, se eliminaran los productos del carrito.",
			icon: "warning",
			showCancelButton: false,
			confirmButtonColor: "#3085d6",
			cancelButtonColor: "#d33",
			confirmButtonText: "Aceptar",
			allowOutsideClick: false
		}).then((result) => {
			$("#nitFactura").on("keyup", delay(function() {
				$("#codCliente").val("");
				cambioCliente("nit");
			},1500));
		});
	}else{
		$("#nitFactura").on("keyup", delay(function() {
			//$("#codCliente").val("");
			validarNITFactura();
			console.log("keyup");
		},900));
	}
});

$("#nitFactura").on("change", function() {
	validarNITFactura();
});

function cambioCliente(param){
	$("#idCategoriaPrecio").val("");
	params = {
		service: "eliminarCarrito",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host,params,function (data) {
		$.each(data, function (key, val) {
			if (val.message === "success") {
				getCarrito();
				getTotalesCarrito();
			} else {
				alert(`Error: ${val.Query}`);
			}
		});
	},"json",
	).done(function () {
		if(param == "codCliente"){
			if($("#codCliente").val() == ""){
				consultaCliente("");
			}else{
				var id = $("#selectClientes").val();
				consultaCliente(id);
			}
		}
	});
}
*/
$("#nitFactura").on("keyup", delay(function () {
	validarNITFactura();
}, 1500));

$("#nit").on("keyup", delay(function () {
	validarNITFactura();
}, 1500));
//Agrega el producto seleccionado al carrito

$("#selectProductos").on("change", function () {

	var idProducto = $('#selectProductos').val();

	params = {
		service: "getDatosProducto",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales,
		idProducto: idProducto
	};
	$.post(host, params, function (data) {
		$.each(data, function (key, val) {
			agregarProductoCarrito(val.id, val.existencia, val.idTipoProductos, val.descLarga, 1, val.precioPublico, 0, 0, 0);
		});
	}, "json");


});

/*

$("#selectProductos").on("change", function () {
	var idProducto = $('#selectProductos').val();
	params = {
		service: "getDatosCargo",
		dbName: dbName,
		id: idProducto,
		idSucursales: localStorage.idSucursales,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
		$.each(data, function (key, val) {
			agregarServicioVenta(val.id,"null",val.sku,val.descLarga,val.precioPublico,val.precioPublico,val.precioCosto,val.idTipoProductos,"null");
		});
	}, "json").done(function(){
	});

});
*/

// Agrega un producto al carrito 
function agregarProductoCarrito(
	idProductos,
	existencia,
	idTipoProductos,
	producto,
	cantidad,
	precioPublico,
	arrGlobal,
	precioDolar,
	agrupar
) {
	if (precioDolar == undefined) { //Para cuando no se manejan precios en dolares
		precioDolar = '0.00';
	}
	params = {
		service: "agregarProductoVenta",
		idProductos: idProductos,
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales,
		idUsuarios: localStorage.idUsuarios,
		cantidad: cantidad,
		precioPublico: precioPublico,
		precioDolar: precioDolar,
		agrupar: agrupar
	};
	$("#loader").show();
	if (idTipoProductos === 1) {
		if (accounting.unformat(existencia) > 0) {
			$.post(host, params, function (data) {
				$.each(data, function (key, val) {
					switch (val.message) {
						case "success":

							getCarrito();
							getTotalesCarrito();
							break;
						case "sin_existencia":
							errorMsg = `No hay existencias de componentes del producto: ${producto} \n`;
							errorMsg += "Producto: " + val.producto + "\n";
							errorMsg +=
								"Exitencia: " + val.existencia + "\n";
							errorMsg +=
								"Cantidad solicitada: " +
								val.cantidad +
								"\n";
							Swal.fire({
								title: `${producto}`,
								text: `No hay existencias de los componentes`,
								icon: "warning",
								confirmButtonColor: "#3085d6",
								confirmButtonText: "Ok",
							}).then((result) => { });
							break;
						default:
							alert(`Error PROD ${val.error}`);
							break;
					}
				});
			}, "json",
			).done(function () {
				$("#loader").hide();
			});
		}
	} else {
		$.post(host, params, function (data) {
			$.each(data, function (key, val) {
				switch (val.message) {
					case "success":
						getCarrito();
						getTotalesCarrito();
						break;
					case "sin_existencia":
						errorMsg = `No hay existencias de componentes del producto: ${producto} \n`;
						errorMsg += "Producto: " + val.producto + "\n";
						errorMsg += "Exitencia: " + val.existencia + "\n";
						errorMsg +=
							"Cantidad solicitada: " + val.cantidad + "\n";
						Swal.fire({
							title: `${producto}`,
							text: `No hay existencias de los componentes`,
							icon: "warning",
							confirmButtonColor: "#3085d6",
							confirmButtonText: "Ok",
						}).then((result) => { });
						break;
					default:
						alert(`Error ${val.error}`);
						break;
				}
			});
		},
			"json",
		).done(function () {
			$("#loader").hide();
		});
	}
}

$("#selectServicios").on("change", function () {
	var idServicio = $('#selectServicios').val();
	getProductosServicio(idServicio);

});

function validarNITFactura() {
	var $this = $("#nitFactura");
	var nit = $this.val();

	if (nit && nitIsValid(nit)) {
		$this.removeClass("invalid");
		$this.addClass("valid");
		consultaNITFactura();
	} else if (nit) {
		$this.removeClass("valid");
		$this.addClass("invalid");
		$("#nombreFactura").val("");
		$("#direccionFactura").val("");
		$("#telefono").val("");
	} else {
		$this.removeClass("valid");
		$this.removeClass("invalid");
		$("nombreFactura").val("");
		$("direccionFactura").val("");
		$("#telefono").val("");
	}
}

function consultaNITFactura() {
	$("#loader").show();
	console.log("consulta");
	if ($("#nitFactura").val().replace(/-/g, "") !== "CF") {
		params = {
			service: "consultaNIT",
			dbName: dbName,
			nit: $("#nitFactura").val().replace(/-/g, ""),
			idEmpresas: localStorage.idEmpresas,
			idUsuarios: localStorage.idUsuarios,
			idSucursales: localStorage.idSucursales
		};
		$.post(host, params, function (data) {
			$.each(data, function (key, val) {
				switch (val.message) {
					case "success":
						$("#nombreFactura").val(val.nombre);
						$("#direccionFactura").val(val.direccion);
						$("#loader").hide();
						break;
					case "error":
						$("#loader").hide();
						break;
					default:
						alert(`${val.message},\nintente ingresar el nit correctamente`);
						$("#loader").hide();
						break;
				}
			});
		}, "json").done(function () {
		});
	}
}

/*
$("#selectClientes").on("change", function () {
	cambioCliente("codCliente");
	console.log("HERE");
	getServicioSelect();
});
*/
/*
function consultaCliente(id) {
	
	if (id == ""){
		$("#idCliente").val("");
		$("#codCliente").val("");
		$("#nitFactura").val("");
		$(".nombre").val("");
		$(".direccion").val("");
		$("#telefono").val("");
		//$("#nitFactura").attr("readonly", false);
		$("#selectClientes").val($("#selectClientes option:first").val());
		getServicioSelect();
	}else{
		params = {
			service: "getDatosCliente",
			dbName: dbName,
			id: id,
			idEmpresas: localStorage.idEmpresas
		};
		$.post(host, params, function (data) {
			//console.log(data)
			if (data !== null) {

				$.each(data, function (key, val) {

					// if(val.nitC == "N/A" || val.nitC == ""){
					// 	$("#nitFactura").attr("readonly", false); 
					// }else{
					// 	$("#nitFactura").attr("readonly", true); 
					// }

					$("#nitFactura").val(val.nitC);
					$("#codCliente").val(val.codigoC);
					console.log(val.id);
					$("#idCliente").val(val.id);
					$(".nombre").val(val.nombreC);
					$(".direccion").val(val.direccionC);
					$("#telefono").val(val.telefonoC);
					getCategoriaPrecio(val.idClasificacionClientes);
					getServicioSelect();

				});
			}
			//else{
			// 	Swal.fire({
			// 		html: 'El codigo de cliente no existe, ingreselo por NIT',
			// 		timer: 2000,
			// 		timerProgressBar: true,
			// 		confirmButtonColor: "#ff8f00",
			// 		confirmButtonText: "Aceptar",
			// 		}).then((result) => {
			// 			$("#nitFactura").attr("readonly", false);
			// 		});
			// }
		}, "json").done(function () {
			$("#loader").hide();
		});
	}
}

*/

//Trae lista de clientes que coinciden con la busqueda
function getClientesSelect(codCliente) {
	params = {
		service: "consultaCliente",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		codCliente: codCliente,
		idSucursales: localStorage.idSucursales
	};
	$.post(host, params, function (data) {
		if (data !== null) {
			let clientes = "<option value='default'>Seleccione un cliente...</option>";
			$.each(data, function (key, val) {
				clientes += `<option value="${val.id}">${val.codigoC} - ${val.nombreC} ${val.nitC}</option>`;
			});
			$("#selectClientes").html(clientes);
		} else {
			Swal.fire({
				html: 'No se encontraron resultados, ingrese el cliente por NIT',
				timer: 2000,
				timerProgressBar: true,
				confirmButtonColor: "#ff8f00",
				confirmButtonText: "Aceptar",
			}).then((result) => {
				$("#nitFactura").attr("readonly", false);
			});
		}
	}, "json");
}

//Obtiene los productos/cargo adicional para mostrarlos en select2
function getProductoSelect() {
	params = {
		service: "getProductos2",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales
	};
	$.post(host, params, function (data) {
		$('#selectProductos').select2({
			//data: data,
			placeholder: "Productos..."
		});
		let productos = "<option></option>";
		$.each(data, function (key, val) {
			productos += `<option value="${val.id}">${val.sku} - ${val.text}</option>`;
		});
		$("#selectProductos").html(productos);
	}, "json");
}

/*
function getServicioSelect(){
	params = {
		service: "getServicios",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales,
		idCliente: $("#idCliente").val()
	};
	$.post(host, params, function (data) {
		$('#selectServicios').select2({
			// 	  data: data,
				   placeholder: "Buscar Servicios..."
			 });
		let productos = "<option></option>";
		$.each(data, function (key, val) {
			productos += `<option value="${val.id}">${val.descripcion}</option>`;
		});
		$("#selectServicios").html(productos);
		
		//console.log(data);
	}, "json",);
}
*/

// obtiene los precios del servicio segun la zona seleccionada
function getZonas(id) {
	params = {
		service: "getZonas",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
	};
	$.post(host, params, function (data) {
		let zonas = `<option value=''></option><option value='.'>...</option>`;
		$.each(data, function (key, val) {
			zonas += `<option value="${val.id}"> ${val.descripcion}</option>`;
		});
		$(`#tipoPrecio${id}`).append(zonas);
		//$('select').formSelect();
	}, "json").done(function () {
		$("#loader").hide();
	});
}

function getBancos() {
	params = {
		service: "getBancos",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
		let bancos = "<option></option>";
		//let bancos = "<option value=''>Seleccione un banco...</option>";
		$.each(data, function (key, val) {
			bancos += `<option value="${val.id}"> ${val.descripcion}</option>`;
		});
		$("#selectBancos").html(bancos);
		$('#selectBancos').select2({
			width: '100%',
			placeholder: "Seleccione un banco...",
		});

	}, "json").done(function () {
		$("#loader").hide();
	});
	$("#selectBancos").on("change", function () {
		console.log($("#selectBancos").val());
	});
}

//Obtiene los cobradores para mostrarlos en select
function getVendedores() {
	params = {
		service: "getVendedores",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales
	};
	$.post(host, params, function (data) {
		let vendedores = "<option value=''>Seleccione un cobrador...</option>";
		$.each(data, function (key, val) {
			vendedores += `<option value="${val.id}"> ${val.codigoUsuario} - ${val.userName}</option>`;
		});
		$("#selectVendedor1").append(vendedores);
		//$('select').formSelect();
	}, "json").done(function () {
		$("#loader").hide();
	});
}

//Dibujar la tabla de articulos idEmpresas api
function getCarrito() {

	$("#tableCarrito tbody").empty();
	params = {
		service: 'loadProductosVenta',
		dbName: dbName,
		idUsuarios: localStorage.idUsuarios,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
		let carrito = ``;
		if (data === null) {
			carrito = `<td colspan="5" style="text-align:center;">0 registros encontrados en el carrito</td>`;
		} else {
			$.each(data, function (key, val) {
				carrito += `
				<tr id="${val.id}">
					<td onclick="eliminarProductoFactura(${val.id}, '${val.descLarga}',${val.idProductos})"><i class="small material-icons">delete</i></td>
					<td><input id="cant${val.id}" min="1" type="number" style="width: 100px; border-bottom: none !important;"/></td>
					<td><input id="desc${val.id}" type="text" style="border-bottom: none !important;" readonly /></td>
					<td><select class="browser-default" id="tipoPrecio${val.id}" style="width: 100px; border-bottom: none !important;font-size: small;"></select>
					</td>
					<td><input id="totalPrecio${val.id}" min="1" type="number" style="width: 100px; border-bottom: none !important;"/></td>
					<td><input id="valorMonto${val.id}" class="valorMonto" type="number" style="width: 100px;border-bottom: none !important;" readonly /></td>
					<td style="display:none;"><input id="idServicio${val.id}" type="number" style="display:none;" readonly /></td>
				</tr>	
				`;
			});
		}
		$("#tableCarrito tbody").html(carrito);

		//Llena los campos de la tabla
		$.each(data, function (key, val) {
			$(`#cant${val.id}`).val(accounting.formatNumber(val.cantidad, 2));
			$(`#desc${val.id}`).val(val.descLarga);
			$(`#totalPrecio${val.id}`).val(parseFloat(val.precio).toFixed(2));
			$(`#valorMonto${val.id}`).val(val.subtotal);
			$(`#idServicio${val.id}`).val(val.idServicio);

			//! DESCOMENTAR SI SE NECESITA TENER LA FUNCIONALIDAD DE CAMBIAR NOMBRES ASI COMO QUITAR EL READONLY DEL CAMPO DE ID=DESC DE ARRIBA
			// $(`#desc${val.id}`).on("keyup", delay(function() {
			// 	var input = $(this).val();
			// 	if(input.length >= 3){
			// 		guardarDetCambios(val.id,$(`#cant${val.id}`).val(),input,$(`#totalPrecio${val.id}`).val(),$(`#valorMonto${val.id}`).val(),$(`#fardoMonto${val.id}`).val());
			// 	}
			// }, 1500));

			$(`#totalPrecio${val.id}`).on("keyup", delay(function () {
				var input = $(this).val();
				if (input.length >= 1) {
					let valor = input;
					let contador = $(`#cant${val.id}`).val();
					valor = valor * contador;
					$(`#valorMonto${val.id}`).val(valor);
					guardarDetCambios(val.id, $(`#cant${val.id}`).val(), $(`#desc${val.id}`).val(), input, $(`#valorMonto${val.id}`).val(), $(`#fardoMonto${val.id}`).val());
				}
			}, 1500));

			$(`#cant${val.id}`).on("keyup", delay(function () {
				var input = $(this).val();
				if (input.length >= 1) {
					let valor = $(`#totalPrecio${val.id}`).val();
					let contador = input;
					valor = valor * contador;
					$(`#valorMonto${val.id}`).val(valor);
					guardarDetCambios(val.id, input, $(`#desc${val.id}`).val(), $(`#totalPrecio${val.id}`).val(), $(`#valorMonto${val.id}`).val(), $(`#fardoMonto${val.id}`).val());
				}
			}, 1500));


			$(`#tipoPrecio${val.id}`).on("change", function () {
				var tipoPrecio = $(`#tipoPrecio${val.id}`).val();
				console.log("categoria:", tipoPrecio);
				getPrecios(val.id, val.idProductos, tipoPrecio, val.precioPublico);
			});
			getZonas(val.id);
		});
	}, 'json').done(function () {

	});

	$('#selectProductos').val(null).trigger('change');
}

// Obtiene la categoria de precios que maneja el cliente en base a su clasificacion.
function getCategoriaPrecio(idClasificacion) {
	params = {
		service: "getCategoriaPrecio",
		dbName: dbName,
		idClasificacionClientes: idClasificacion,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
		$.each(data, function (key, val) {
			$('#idCategoriaPrecio').val(val.idCategoriaPrecio);
		});
	}, "json").done(function () { });
}


function getPrecios(id, idProducto, idCategoria, precioPublico) {

	if (idCategoria == ".") {
		var cantidad = accounting.unformat($(`#cant${id}`).val());
		$(`#totalPrecio${id}`).val(precioPublico);
		$(`#valorMonto${id}`).val(precioPublico * cantidad);
		guardarDetCambios(id, $(`#cant${id}`).val(), $(`#desc${id}`).val(), $(`#totalPrecio${id}`).val(), $(`#valorMonto${id}`).val(), $(`#fardoMonto${id}`).val());
	} else {
		params = {
			service: "getPrecios",
			dbName: dbName,
			idProducto: idProducto,
			idCategoria: idCategoria
		};
		$.post(host, params, function (data) {

			var cantidad = accounting.unformat($(`#cant${id}`).val());
			$.each(data, function (key, val) {
				$(`#totalPrecio${id}`).val(val.precio);
				$(`#valorMonto${id}`).val(val.precio * cantidad);
			});
		}, "json").done(function () {
			guardarDetCambios(id, $(`#cant${id}`).val(), $(`#desc${id}`).val(), $(`#totalPrecio${id}`).val(), $(`#valorMonto${id}`).val(), $(`#fardoMonto${id}`).val());
		});
	}
}


function getTotalesCarrito() {
	params = {
		service: 'loadProductosVenta',
		dbName: dbName,
		idUsuarios: localStorage.idUsuarios,
		idEmpresas: localStorage.idEmpresas
	};
	$.post(host, params, function (data) {
		var total = 0;
		var total2 = 0;
		var totalFardos = 0;
		if (data === null) {
			$("#totalItems").val(0);
			$("#total").val(0);
			var summary = `<tr style="background-color: #263238 !important;color:  #FFF !important;border: 0 !important;">
				<td colspan="4"></td>
				<td>Total Q</td>
				<td id="totalFacturacion1">${accounting.formatNumber(total, 2)}</td>
				<input type="hidden" id="totalFacturacion" value="${total}" />
			</tr>`;
		} else {
			$.each(data, function (key, val) {
				totalFardos += accounting.unformat(val.cantFardos);
				total += accounting.unformat(val.subtotal);
				total2 += accounting.unformat(val.cantidad);
			});
			$("#totalItems").val(total2);
			$("#total").val(total);
			var summary = `<tr style="background-color: #263238 !important;color:  #FFF !important;border: 0 !important;">
			<td colspan="4"></td>
			<td>Total Q</td>
			<td id="totalFacturacion1">${accounting.formatNumber(total, 2)}</td>
			<input type="hidden" id="totalFacturacion" value="${total}" />
			
		</tr>`;
		}
		$("#tableCarrito tfoot").html(summary);
	}, 'json').done(function () { });
}

function verificarCampos() {
	var nombre = !$("#nombreFactura").val() ? "Consumidor Final" : $("#nombreFactura").val();
	var direccion = !$("#direccionFactura").val() ? "Consumidor Final" : $("#direccionFactura").val();
	var nit = !$("#nitFactura").val() ? "CF" : $("#nitFactura").val();
	var cliente = $("#idCliente").val();
	var email = $("#email").val();
	// if(nit == "N/A"){
	// 	$("#nitFactura").val("CF");
	// }

	//var telefono = $("#telefono").val();
	var vendedor = $("#selectVendedor1").val();

	var errorMsg = "<b>Campos obligatorios pendientes: </b></br>";
	var flag = true;
	if (!nit) {
		flag = false;
		errorMsg += "Ingrese el NIT </br>";
	}

	var totalF = accounting.unformat($("#totalFacturacion").val());

	/*
	if (!vendedor) {
		flag = false;
		errorMsg += "Seleccione un cobrador </br>";
	}
	*/
	if (totalF <= 0) {
		flag = false;
		errorMsg += "El total del cobro no puede ser 0.00 </br>";
	}

	var EmailRegex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;


	if (email != "") {
		if (email == undefined || !EmailRegex.test(email)) {
			flag = false;
			errorMsg += "Debe ingresar un correo electronico valido </br>";
		} else {
			$("#enviarCorreo").prop("checked", true);
		}
	}

	/*
	if (!cliente) {
		flag = false;
		errorMsg += "Ingrese un cliente	 </br>";
	}
	if (!vendedor) {
		flag = false;
		errorMsg += "Seleccione un cobrador </br>";
	}
	*/

	if (!nombre || !direccion) {
		flag = false;
		errorMsg += "Ingrese un NIT valido </br>";
	}
	if (flag === false) {
		Swal.fire({
			html: errorMsg,
			icon: "warning",
			confirmButtonColor: "#3085d6",
			confirmButtonText: "Intentar de nuevo",
		}).then((result) => { });
		return false;
	} else {
		//formasPago();
		getDatosVenta();
	}
}

function validacionCarritoFactura() {
	if ($("#totalItems").val() === undefined || $("#totalItems").val() === '0') {
		Swal.fire({
			html: 'No tiene articulos en esta venta',
			timer: 2000,
			timerProgressBar: true,
			confirmButtonColor: "#ff8f00",
			confirmButtonText: "Aceptar",
		}).then((result) => { });
	} else {
		verificarCampos();
	}
}

function formasPago() {
	Swal.fire({
		title: `Seleccione la Forma de Pago`,
		html: `<div class="row"><div class= "col s6" style="padding-top: 20px;text-align:end;"><b>Efectivo: Q</b></div>
		<div  class="col s6">
			<input class="formasPago" id="efectivoPago" placeholder="Cantidad en Efectivo" data-type="1" data-emisor="0" required type="number"/>
		</div>
		<div class= "col s6" style="padding-top: 20px;text-align:end;"><b>VISA: Q</b></div>
		<div  class="col s6">
			<input class="formasPago" id="visaPago" placeholder="Cantidad en VISA" data-type="5" data-emisor="1" required type="number"/>
		</div>

		<div id="bloqueVisa" style="display:none">
			<div class= "col s6" style="padding-top: 20px;text-align:end;"><b>No. Autorizacion:</b></div>
			<div  class="col s6">
				<input id="autorizacionVisa" placeholder="Numero de Autorizacion" required type="number"/>
			</div>
		</div>

		<div class= "col s6" style="padding-top: 20px;text-align:end;"><b>Cheque: Q</b></div>
		<div  class="col s6">
			<input class="formasPago" id="chequesPago" placeholder="Cantidad en Cheque" data-type="3" data-emisor="0" required type="number"/>
		</div>
		<div id="bloqueCheque" style="display:none">
			<div class= "col s6" style="padding-top: 20px;text-align:end;"><b>Banco:</b></div>
			<div  class="col s6" style="padding-top: 15px;">
			<select class="select2" id="selectBancos" style="border-top-width: 10px;font-size: small;border: 1px solid white;border-bottom-color: #545454;"></select>
			</div>
			<div class= "col s6" style="padding-top: 20px;text-align:end;"><b>No. Cheque: </b></div>
			<div  class="col s6">
				<input id="numeroCheque" placeholder="Numero de Cheque" required type="number"/>
			</div>
		</div>
		<div class= "col s6" style="padding-top: 20px;text-align:end;"><b>Cambio: Q</b></div>
		<div class="col s6">
			<input id="cambio" type="number" readonly/>
		</div>
		<div class= "col s6" style="padding-top: 20px;text-align:end;"><b>Total Restante: Q</b></div>
		<div class="col s6">
			<input id="totalResto" type="number" readonly/>
		</div>
		</div>`,
		showConfirmButton: true,
		showCancelButton: true,
		confirmButtonColor: '#ff8f00',
		cancelButtonText: "Cancelar",
		confirmButtonText: "FACTURAR",
		onOpen() {
			getBancos();
		},
		customClass: {
			container: 'my-swal'
		}
	}).then((result) => {
		if (result.isConfirmed) {
			if ($("#totalResto").val() === "0.00") { //Agregar validacion de ingreso del numero de cheque, banco y autorizacion...				
				if ($("#visaPago").val() != "" && $("#autorizacionVisa").val() == "") {
					Swal.fire({
						icon: "warning",
						text: "Ingrese un numero de autorizacion",
						showCloseButton: true,
						confirmButtonText: "Intentar de nuevo",
						confirmButtonColor: "#3085d6",
					}).then((result) => { });
				} else if ($("#chequesPago").val() != "") {
					var errorMsg = "<b>Revise los siguientes campos: </b></br>";
					var flag = true;
					if ($("#numeroCheque").val() == "") {
						flag = false;
						errorMsg += "Ingrese el n&uacute;mero de cheque </br>";
					}
					if ($("#selectBancos").val() == "") {
						flag = false;
						errorMsg += "Seleccione un banco</br>";
					}
					if (flag === false) {
						Swal.fire({
							html: errorMsg,
							icon: "warning",
							confirmButtonColor: "#3085d6",
							confirmButtonText: "Ok",
						}).then((result) => { });
						return false;
					} else {
						//console.log("Finalizar Factura 2");
						//agregar funcion que vaya a insertar el servicio a la tabla serviciosCliente
						finalizarFactura();
						//validacionNIT();
					}
				} else {
					//console.log("Finalizar Factura 1");
					finalizarFactura();
					//validacionNIT();
				}
			} else {
				Swal.fire({
					icon: "warning",
					text: "Debe ingresar montos validos y liquidar el total",
					showCloseButton: true,
					confirmButtonText: "Intentar de nuevo",
					confirmButtonColor: "#3085d6",
				}).then((result) => { });
			}
		}
	});

	$("#totalResto").val(parseFloat($("#total").val()).toFixed(2));

	$("#efectivoPago").on("keyup", function () {
		let totalResto = $("#totalResto").val();
		var valor = 0;
		$(".formasPago").each(function (index) {
			valor += accounting.unformat($(this).val());
			totalResto = $("#total").val() - valor;
		});
		if (totalResto < 0) {
			$("#totalResto").val(accounting.formatNumber(0, 2));
		} else {
			$("#totalResto").val(totalResto.toFixed(2));
		}
	});

	$("#visaPago").on("keyup", function () {
		let totalResto = $("#totalResto").val();
		var valor = 0;
		$(".formasPago").each(function (index) {
			valor += accounting.unformat($(this).val());
			totalResto = $("#total").val() - valor;
		});
		$("#totalResto").val(totalResto.toFixed(2));

		if ($(`#visaPago`).val() != 0) {
			$('#bloqueVisa').css('display', 'block');
		} else {
			$('#bloqueVisa').css('display', 'none');
		}
		$("#cambio").val(accounting.formatNumber(0, 2));
	});

	$("#chequesPago").on("keyup", function () {
		let totalResto = $("#totalResto").val();
		var valor = 0;
		$(".formasPago").each(function (index) {
			valor += accounting.unformat($(this).val());
			totalResto = $("#total").val() - valor;
		});
		$("#totalResto").val(totalResto.toFixed(2));

		if ($(`#chequesPago`).val() != 0) {
			$('#bloqueCheque').css('display', 'block');
		} else {
			$('#bloqueCheque').css('display', 'none');
		}
		$("#cambio").val(accounting.formatNumber(0, 2));
	});

	$("#efectivoPago").on("keyup", function () {
		var total = accounting.unformat($("#total").val());
		let calcCambio = $("#cambio").val();
		var valor = 0;
		$("#efectivoPago").each(function (index) {
			valor += accounting.unformat($(this).val());
			calcCambio = valor - total;
			if (calcCambio < 0) {
				calcCambio = 0
			}
		});
		$("#cambio").val(accounting.formatNumber(calcCambio, 2));
	});
}

function validacionNIT() {
	$("#loader").show();
	if ($("#nitFactura").val().replace(/-/g, "") !== "CF") {
		params = {
			service: "consultaNIT",
			dbName: dbName,
			nit: $("#nitFactura").val().replace(/-/g, ""),
			idEmpresas: localStorage.idEmpresas,
			idUsuarios: localStorage.idUsuarios,
			idSucursales: localStorage.idSucursales
		};
		$.post(host, params, function (data) {
			$.each(data, function (key, val) {
				switch (val.message) {
					case "success":
						finalizarFactura();
						break;
					case "error":
						$("#nitFactura").val("CF");
						finalizarFactura();
						break;
					default:
						break;
				}
			});
		}, "json").done(function () {
			$("#loader").hide();
		});
	} else {
		finalizarFactura();
		$("#loader").hide();
	}

}

//validacion para referencia interna si se selecciona crédito al pagar;
function validarCredito() {
	var errorMsg = "<b>Campos obligatorios pendientes: </b></br>";
	var flag = true;
	var referencia = $("#referenciaInterna").val();

	if (!referencia && $('#tipoVenta').is(":checked")) {
		flag = false;
		errorMsg += "Ingrese una referencia interna unica </br>";
	}

	if (flag === false) {
		Swal.fire({
			html: errorMsg,
			icon: "warning",
			confirmButtonColor: "#3085d6",
			confirmButtonText: "Intentar de nuevo",
		}).then((result) => { });
		return false;
	} else {
		finalizarFactura();
	}
}

function finalizarFactura() {
	//Guardar los datos introducidos en la tabla de ventas y en la tabla de envios
	$('#btnFinVenta').attr('disabled', 'disabled');
	$("#loader").show();
	try {
		//var tipoTransaccion = 1;

		let chkTipTrans = $("#chkTipoTransaccion").prop("checked");
		console.log("tipo transac:", chkTipTrans);
		if ($("input[name=envioEspecial]:checked").val() == "on") {
			console.log("Recibo");
			tipoTransaccion = 0;
		}

		if (chkTipTrans) {
			idDocumento = $("#idDocumento").val();
			serie = $("#serie").val();
			correlativo = $("#correlativo").val();
			//documento = $("#documento").val();
			documento = $("#factura").val();
		} else {
			idDocumento = $("#idDocumentoE").val();
			serie = $("#serieE").val();
			correlativo = $("#correlativoE").val();
			//documento = $("#documentoE").val();
			documento = $("#factura").val();

		}

		var tipoVenta;
		var anticipo;
		if ($('#tipoVenta').is(":checked")) {
			tipoVenta = 1;
			anticipo = accounting.unformat($("#TxtTotal").val());
		} else {
			tipoVenta = 0;
			anticipo = 0;
		}

		//! Detalle de formas pago y emisores

		var detalle = [];
		$(".formasPago").each(function (index) {
			if (accounting.unformat($(this).val()) != 0) {
				var arr = {};
				arr["idFormasPago"] = $(this).data("type");
				arr["idEmisor"] = $(this).data("emisor");
				arr["valor"] = accounting.unformat($(this).val());
				if ($(this).data("type") == 5) { //Tarjeta VISA
					arr["auth"] = $("#autorizacionVisa").val();
				} else if ($(this).data("type") == 3) { //Cheque
					arr["auth"] = $("#numeroCheque").val();
					arr["idEmisor"] = $("#selectBancos").val();
				}
				detalle.push(arr);
			}
		});

		if ($('#tipoVenta').is(":checked") && detalle.length == 0) {
			var arr = {};
			arr["idFormasPago"] = 4;
			arr["idEmisor"] = 0;
			arr["valor"] = accounting.unformat($("#TxtSaldo").val());
			detalle.push(arr);
		}

		//! TOTALES
		var totalFactura = accounting.unformat($("#totalFacturacion").val());
		var iva = accounting.unformat(((totalFactura / 1.12) * 0.12 * 100) / 100);
		var total = accounting.unformat(totalFactura - iva);
		//var descuento = accounting.unformat($("#totalDescontado").val());
		var descuento = 0;
		var subtotal = accounting.unformat($("#totalFacturacion").val());

		var nombre = !$("#nombre").val() ? "Consumidor Final" : $("#nombre").val();
		var direccion = !$("#direccion").val() ? "Consumidor Final" : $("#direccion").val();

		//replace name and address
		nombre = nombre.replace("&", "%26");
		direccion = direccion.replace("&", "%26");

		var vendedor = $("#selectVendedor1").val();
		let idCliente = $("#idCliente").val();

		if ($("#nitFactura").val() == "N/A") {
			$("#nitFactura").val("CF");
		}

		if ($("#nitFactura").hasClass("invalid")) {
			$("#nitFactura").val("CF");
		}

		var nit = !$("#nit").val() ? "CF" : $("#nit").val();

		let serviceAPI;

		let referenciaInterna = $('#referenciaInterna').val();

		if (tipoVenta == 0) {
			serviceAPI = "finalizarVenta";
		} else {
			serviceAPI = "finalizarVentaCambiaria";
		}

		params = {
			service: serviceAPI,
			dbName: dbName,
			urlFEL: urlFEL,
			tokenFEL: tokenFEL,
			idVendedor: vendedor,
			idUsuarios: localStorage.idUsuarios,
			idSucursales: localStorage.idSucursales,
			idEmpresas: localStorage.idEmpresas,
			totalFactura: totalFactura,
			total: subtotal,
			nombre: nombre,
			nit: nit,
			direccion: direccion,
			subtotal: subtotal,
			descuentoM: descuento,
			descuentoP: 0,
			anticipo: anticipo,
			saldo: accounting.unformat($("#TxtSaldo").val()),
			iva: iva,
			tasaCambio: 0,
			totalDolares: 0,
			tipoVenta: tipoVenta,
			idDocumento: idDocumento,
			serie: serie,
			correlativo: correlativo,
			documento: documento,
			tipoTransaccion: chkTipTrans ? 1 : 0,
			detalle: detalle,
			codigoMoneda: "GTQ",
			nitExt: 0,
			referenciaInterna: referenciaInterna
		};
		console.log(params);
		$.post(host, params, function (data) {
			$.each(data, function (key, val) {
				switch (val.message) {
					case "success":
						//En printer es donde se hace la evaluacion de imprimir o enviar correo
						printer(val.idVenta, 1, false, 0);
						
						if ($('#tipoVenta').is(":checked")) {
							guardarSaldoActual();
						}
						if ($('#regalo').is(':checked')) {
							printerCambio(val.idVenta, 0);
						}
						break;
					case "docExists":
						alert("Correlativo de documento ya existe en el sistema");
						break;
					default:
						alert(val.error);
						break;
				}
			});
		}, "json").done(function () {
			$("#loader").hide();
		});
	} catch (err) {
		Swal.fire({
			html: err.message,
			icon: "error",
			confirmButtonColor: "#3085d6",
			confirmButtonText: "Ok",
		}).then((result) => { });
		$("#loader").hide();
		return false;
	}
}

//Guarda los campos de la tabla si es que se modificaron;
function guardarDetCambios(id, cant, desc, precio, valor, fardos) {
	var descripcion = desc.replace(/[_\W]+/g, " ");
	var cantidad = cant;

	if (cant < 0 || cant == "" || precio < 0 || precio == "" || descripcion == "" || fardos < 0) {
		Swal.fire({
			text: `Introduce un valor valido`,
			icon: "warning",
			confirmButtonColor: "#3085d6",
			confirmButtonText: "Ok",
		}).then((result) => { });
	} else {
		params = {
			service: "guardarDetCambios",
			dbName: dbName,
			idSucursales: localStorage.idSucursales,
			idUsuarios: localStorage.idUsuarios,
			idEmpresas: localStorage.idEmpresas,
			id: id,
			desc: descripcion,
			cant: cantidad,
			precio: precio,
			valor: valor,
			fardos: fardos,
			//idServicio: idServicio //conjunto de productos
		};
		$.post(host, params, function (data) {
		}, "json").done(function () {
			console.log("Saved!");
			getTotalesCarrito();
		});
	}
}

function eliminarProductoFactura(id, descLarga, idProductos) {
	$("#loader").hide();
	Swal.fire({
		title: "&iquest;Eliminar Producto?",
		text: `${descLarga}`,
		icon: "warning",
		showCancelButton: true,
		confirmButtonColor: "#3085d6",
		cancelButtonColor: "#d33",
		confirmButtonText: "Si",
		cancelButtonText: "Cancelar",
	}).then((result) => {
		if (result.value) {
			params = {
				service: "eliminarProductoVenta",
				dbName: dbName,
				id: id,
				idProductos: idProductos
			};
			$.post(
				host,
				params,
				function (data) {
					$.each(data, function (key, val) {
						if (val.message === "success") {
							getCarrito();
							getTotalesCarrito();
						} else {
							alert(`Error: ${val.Query}`);
						}
					});
				},
				"json",
			);
		}
	});
}


//Construccion de la factura...
function getHeaderFactura() {
	$("#headers").html("");
	$("#facturaFoot").html("");
	params = {
		service: "printFacturaEnvioHeader",
		dbName: dbName
	};
	$.post(host, params, function (data) {
		//console.log(data);
		let headers = ``;
		let summary = ``;
		let foot = ``;
		let foot1 = ``;
		$.each(data, function (key, val) {
			var logo;
			//Seleccion de datos empresa
			switch (val.idEmpresas) {
				case "1":
					logo = "unicable.jpg";
					break;
				case "2":
					logo = "proyectosCipresales.jpg";
					break;
				case "3":
					logo = "cableSanAntonio.jpg";
					break;
				default:
					logo = "unicable.jpg";
					break;
			}

			if (val.autorizacionFEL === null) {
				var autorizacion = "N/A";
			} else {
				var autorizacion = val.autorizacionFEL;
			}
			if (val.fechaEmisionFEL === null) {
				var fechaHora = "N/A";
			} else {
				var fechaHora = val.fechaEmisionFEL;
			}
			headers += `
			<div style="display: grid;grid-template-columns: auto auto auto auto;">
				<div style="grid-column: 1 / span 3;text-align: center;">
					<img src="assets/images/${logo}" style="height: 60px;" /></br>
					<div style="display: inline-block;font-size: smaller;text-align: center;">
					<b style="font-size: x-large;">UNICABLE</b></br>
					CABLE, INTERNET Y DATOS</br>

					</div>
				</div>

				<div style="grid-column: 4/ span 2">
					<div style="background-color: #ee9b1b;color: white;border: 1px solid;border-bottom: unset;border-top-left-radius:15px;border-top-right-radius:15px;
					padding-left: 15px !important;padding: unset;text-align:center;">
						<b>DATOS DE LA FACTURA</b>
					</div>
					<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding-left: 15px !important;padding: unset;margin-bottom: 5px;">
						<b>No. AUTORIZACI&Oacute;N: </b> ${autorizacion} </br>
						<b>SERIE DE DOCUMENTO: </b> ${val.serie} </br>
						<b>No. DTE: </b> ${val.correlativo} </br>
						<b>FECHA DE EMISI&Oacute;N: </b> ${fechaHora} </br>
						<b>SALDO: </b> 
					</div>
				</div>

				<div class="sectionHeader" style="grid-column:1 / span 5;">
					<b>DATOS DEL CLIENTE</b>
				</div>
				<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding-left: 15px !important;padding: 10px; grid-column:1 / span 5">
					<b>NOMBRE DEL CLIENTE: </b>${val.nombre}<br>
					<b>NIT: </b>${val.nit}<br>
					<b>DIRECCI&Oacute;N: </b>${val.direccion}<br>
					<b>C&Oacute;DIGO DE CLIENTE: </b>${val.codigoC}<br>
				</div>

						
			</div>`;
			foot1 += `
			<div class="sectionHeader" style="grid-column: 4 / span 2;">
					<b>TOTAL DE FACTURA</b>
			</div>
			<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding: 05px; grid-column: 4 / span 2;text-align:center;margin-bottom:05px;">
				<b>Q${accounting.formatNumber(val.total, 2)}</b>
			</div>

			<div class="sectionHeader" style="grid-column:1 / span 5;">
					<b>TOTAL EN LETRAS</b>
			</div>
			<div style="margin-bottom:10px;border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding: 05px; padding-left: 15px !important;grid-column:1 / span 5">
				<b>${val.totalEnLetras}</b>
			</div>
			
			<div class="sectionHeader" style="grid-column: 4 / span 2;">
					<b>FORMA DE PAGO</b>
			</div>
			<div style="border: 1px solid;border-bottom-left-radius:15px;border-bottom-right-radius:15px;padding: 05px; grid-column: 4 / span 2;text-align:center;margin-bottom:05px;">
				<b>${val.formaPago}</b>
			</div>
			`;
			foot += `<div style="margin-top: 10px;margin-right: 10px;font-size: smaller;"><b>CERTIFICADOR: Digifact, S.A. NIT: 77454820 </b></br><b>DOCUMENTO ELECTRONICO, SUJETO A PAGOS TRIMESTRALES</b></br></div>
			`;
		});
		$("#headers").html(headers);
		//$("#bodyTable tfoot").html(summary);
		$("#facturaFoot").html(foot);
		$("#facturaFoot1").html(foot1);
	}, "json").done(function () {
		getDetallesFactura();
	});
}

function getDetallesFactura() {
	$("#bodyTable tbody").html("");
	params = {
		service: "printFacturaEnvioDetail",
		dbName: dbName
	};
	$.post(host, params, function (data) {
		let table = ``;
		var total = 0;

		$.each(data, function (key, val) {
			total += accounting.unformat(val.total);
			table += `
				<tr>
					<td style="padding-left: 15px">${val.cantidad}</td>
					<td style="padding-left: 15px">${val.descLarga}</td>
					<td style="padding-left: 15px">${val.precioServicio}</td>
				</tr>
			`;
		});
		$("#bodyTable tbody").html(table);
	}, "json").done(function () {
	});
}

function popUpFactura() {
	var popup = window.open("facturaPrint.html", "", "width=1000,height=800");
}

//! Funciones exclusivas para manejar propershop con envios...
function getTransportistas() {
	params = {
		service: "getTransportistas",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
		idSucursales: localStorage.idSucursales
	};
	$.post(host, params, function (data) {
		let pilotos = "<option value=''>Seleccione un transportista...</option>";
		$.each(data, function (key, val) {
			pilotos += `<option value="${val.userName}"> ${val.codigoUsuario} - ${val.userName}</option>`;
		});
		$("#selectTransportista").append(pilotos);
		//$('select').formSelect();
	}, "json").done(function () {
		$("#loader").hide();
	});
}

function guardarDatosEnvio() {
	$("#loader").show();
	try {
		//! Valores de entrada
		var ordenCompra = $("#ordenCompra").val().replace(/[_\W]+/g, " ");
		var direccionEnvio = $("#direccionEnvio").val().replace(/[_\W]+/g, " ");
		var pedido = $("#pedido").val().replace(/[_\W]+/g, " ");
		//! CANTIDAD DE BULTOS
		var bultos = $("#bultos").val();
		var telefono = $("#telefono").val().replace(/[_\W]+/g, " ");
		var transporte = $("#transporte").val().replace(/[_\W]+/g, " ");
		var transportista = $("#selectTransportista").val();
		var tipoEnvio = $("#tipoEnvio").val();
		var codigo = $("#selectVendedor1").val();

		if ($("input[name=generarEnvio]:checked").val() == undefined) {
			direccionEnvio = "NA";
			transporte = "NA";
			telefono = "0";
			transportista = "NA";
		}
		if ($("input[name=envioEspecial]:checked").val() == "on") {
			var envioEspecial = 1;
		} else {
			var envioEspecial = 0;
		}
		params = {
			service: "guardarDatosEnvio",
			dbName: dbName,
			urlFEL: urlFEL,
			tokenFEL: tokenFEL,
			idUsuarios: localStorage.idUsuarios,
			idSucursales: localStorage.idSucursales,
			idEmpresas: localStorage.idEmpresas,
			ordenCompra: ordenCompra,
			direccionEnvio: direccionEnvio,
			transporte: transporte,
			pedido: pedido,
			bultos: bultos,
			envioEspecial: envioEspecial,
			codigo: codigo,
			transportista: transportista,
			telefono: telefono,
			tipoEnvio: tipoEnvio
		};
		$.post(host, params, function (data) {
			$.each(data, function (key, val) {
				switch (val.message) {
					case "success":
						//Cargar funcion que imprima los recibos
						//Si se selecciono envio especial, no se factura
						if ($("input[name=envioEspecial]:checked").val() == "on") {
							console.log("Recibo");
							popUpEnvioRecibo();
						} else {
							if ($("input[name=generarEnvio]:checked").val() == "on") {
								popUpEnvio();
								popUpFactura();
							} else {
								popUpFactura();
							}
						}
						location.reload();
						break;
					default:
						alert(val.error);
						break;
				}
			});
		}, "json").done(function () {
			$("#loader").hide();
		});
	} catch (err) {
		Swal.fire({
			html: err.message,
			icon: "error",
			confirmButtonColor: "#3085d6",
			confirmButtonText: "Ok",
		}).then((result) => { });
		$("#loader").hide();
		return false;
	}
}
//Construccion del formato para el documento de imprecion de envio
function getHeaderEnvio() {
	$("#headerEnvio").html("");
	$("#envioFoot").html("");
	params = {
		service: "printFacturaEnvioHeader",
		dbName: dbName
	};
	$.post(host, params, function (data) {
		//console.log(data);
		let headersEnvio = ``;
		let summary = ``;
		let pageFoot = ``;
		$.each(data, function (key, val) {
			if (val.autorizacionFEL === null) {
				autorizacion = "N/A";
			} else {
				autorizacion = val.autorizacionFEL;
			}
			headersEnvio += `
			<div style="display: grid;grid-template-columns: auto auto auto auto;">
				<div style="grid-column: 1 / span 2">
					<img src="assets/images/" style="width: 105px; height: 100px;" />
					<div style="display: inline-block;font-size: smaller;text-align: center;">
					</div>
				</div>
				<div style="border: 1px solid;border-top-right-radius:10px;border-top-left-radius:20px;border-bottom-right-radius:10px;padding-left: 15px;padding-top: 10px;margin-top: 50px;padding-bottom: 11px;grid-column: 3 / span 2;">
				<b>GUATEMALA - FECHA: </b>${val.fechaFactura}
				</div>
				<div style="border: 1px solid;border-right:none;border-bottom: none;border-top-left-radius:10px;padding-left: 15px;grid-column: 1 / span 2;padding-left: 15px !important;padding: unset;"><b>NOMBRE:</b> ${val.nombre} <br/>
					<b>DIRECCI&Oacute;N:</b> ${val.direccionEnvio}
				</div>
				<div style="border: 1px solid;border-left:none;border-bottom: none;border-top-right-radius:10px;padding-left: 15px !important;padding: unset;grid-column: 4 ;">
					<b>NIT:</b> ${val.nit} </br>
					<b>TEL:</b> ${val.telefono}
				</div>
				<div style="border-left: 1px solid;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 1 / span 2;">
					<b>SERIE:</b> ${val.serie} &emsp; &emsp; <b>DTE:</b> ${val.correlativo} </br><b>AUTORIZACION:</b> ${autorizacion} 
				</div>
				<div style="border-right: 1px solid;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 3 / span 2 ;">
					<b>PEDIDO No.:</b> ${val.pedido}
				</div>
				<div style="border: 1px solid;border-bottom-left-radius:20px;border-right: none;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 1 / span 2;">
					<b>TRANSPORTE: </b> ${val.transporte}
				</div>
				<div style="border: 1px solid;border-bottom-right-radius:20px;border-left: none;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 3 / span 2 ;">
					<b>CANTIDAD DE BULTOS:</b> ${val.cantBultos}
				</div>
			</div>	
			`;
			if (val.tipoEnvio == '1') {
				summary += `<tr>
				<td colspan="2" style="padding-left: 15px;"><b>EN LETRAS: </b></br> ${val.totalEnLetras}</td>
				<td style="font-size: large;"><b>Total Q</b></td>
				<td style="padding-right: 15px;font-size: large;"><b>${accounting.formatNumber(val.total, 2)}</b></td>
			</tr>
			`;
			} else {
				summary += `<tr>
				<td colspan="2" style="padding-left: 15px;"><b>EN LETRAS:</b></br></td>
				<td style="font-size: large;"><b>Total Q</b></td>
				<td style="padding-right: 15px;font-size: large;"><b>0.00</b></td>
				</tr>
			`;
			}
			pageFoot += `<div style="text-align: center;margin-top: 20px;font-size: smaller;"><pre><b>ENTREGO: </b>${val.transportista}<b>	RECIB&Iacute:</b>_____________________________</pre></div>
			`;
		});
		$("#headerEnvio").html(headersEnvio);
		$("#bodyTableEnvio tfoot").html(summary);
		$("#envioFoot").html(pageFoot);
	}, "json").done(function () {
		getDetallesEnvios();
	});
}

function getDetallesEnvios() {
	$("#bodyTableEnvio tbody").html("");
	params = {
		service: "printFacturaEnvioDetail",
		dbName: dbName
	};
	$.post(host, params, function (data) {
		let table = ``;
		var total = 0;
		var totales = ``;
		$.each(data, function (key, val) {
			if (val.tipoEnvio == '1') {
				totales = val.total;
			} else {
				totales = "0.00";
			}
			total += accounting.unformat(val.total);
			table += `
				<tr>
					<td style="padding-left: 15px">${val.cantidad}</td>
					<td style="padding-left: 15px">${val.descLarga}</td>
					<td style="padding-left: 15px">${val.cantFardos}</td>
					<td style="padding-left: 15px">${totales}</td>
				</tr>
			`;
		});
		$("#bodyTableEnvio tbody").html(table);
	}, "json").done(function () {
	});
}

function popUpEnvio() {
	var popup = window.open("envioPrint.html", "", "width=1000,height=800");
}

//Construccion del formato para el documento de imprecion de envio
function getHeaderEnvioRecibo() {
	$("#headerEnvioRecibo").html("");
	$("#envioFootRecibo").html("");
	params = {
		service: "printFacturaEnvioHeader",
		dbName: dbName
	};
	$.post(host, params, function (data) {
		let headersEnvio = ``;
		let summary = ``;
		let pageFoot = ``;
		$.each(data, function (key, val) {
			headersEnvio += `
			<div style="display: grid;grid-template-columns: auto auto auto auto;">
				<div style="grid-column: 1 / span 2">
					<img src="assets/images/" style="width: 105px; height: 100px;" />
					<div style="display: inline-block;font-size: smaller;text-align: center;">
					</div>
				</div>
				<div style="border: 1px solid;border-top-right-radius:10px;border-top-left-radius:20px;border-bottom-right-radius:10px;padding-left: 15px;padding-top: 10px;margin-top: 50px;padding-bottom: 11px;grid-column: 3 / span 2;">
					<b>RECIBO DE ENVIO</b></br>
					<b>GUATEMALA - FECHA: </b>${val.fechaFactura}
				</div>
				<div style="border: 1px solid;border-right:none;border-bottom: none;border-top-left-radius:10px;padding-left: 15px;grid-column: 1 / span 2;padding-left: 15px !important;padding: unset;"><b>NOMBRE:</b> ${val.nombre} <br/>
					<b>DIRECCI&Oacute;N:</b> ${val.direccionEnvio}
				</div>
				<div style="border: 1px solid;border-left:none;border-bottom: none;border-top-right-radius:10px;padding-left: 15px !important;padding: unset;grid-column: 4 ;">
					<b>NIT:</b> ${val.nit} </br>
					<b>TEL:</b> ${val.telefono}
				</div>
				<div style="border-left: 1px solid;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 1 / span 2;">
				</div>
				<div style="border-right: 1px solid;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 3 / span 2 ;">
					<b>PEDIDO No.:</b> ${val.pedido}
				</div>
				<div style="border: 1px solid;border-bottom-left-radius:20px;border-right: none;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 1 / span 2;">
					<b>TRANSPORTE: </b> ${val.transporte}
				</div>
				<div style="border: 1px solid;border-bottom-right-radius:20px;border-left: none;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 3 / span 2 ;">
					<b>CANTIDAD DE BULTOS:</b> ${val.cantBultos}
				</div>
			</div>	
			`;
			if (val.tipoEnvio == '1') {
				summary += `<tr>
				<td colspan="2" style="padding-left: 15px;"><b>EN LETRAS: </b></br> ${val.totalEnLetras}</td>
				<td style="font-size: large;"><b>Total Q</b></td>
				<td style="padding-right: 15px;font-size: large;"><b>${accounting.formatNumber(val.total, 2)}</b></td>
			</tr>
			`;
			} else {
				summary += `<tr>
				<td colspan="2" style="padding-left: 15px;"><b>EN LETRAS:</b></br></td>
				<td style="font-size: large;"><b>Total Q</b></td>
				<td style="padding-right: 15px;font-size: large;"><b>0.00</b></td>
				</tr>
			`;
			}
			pageFoot += `<div style="text-align: center;margin-top: 20px;font-size: smaller;"><pre><b>ENTREGO: </b>${val.transportista}<b>	RECIB&Iacute:</b>_____________________________</pre></div>
			`;
		});
		$("#headerEnvioRecibo").html(headersEnvio);
		$("#bodyTableEnvioRecibo tfoot").html(summary);
		$("#envioFootRecibo").html(pageFoot);
	}, "json").done(function () {
		getDetallesEnviosRecibo();
	});
}

function getDetallesEnviosRecibo() {
	$("#bodyTableEnvioRecibo tbody").html("");
	params = {
		service: "printFacturaEnvioDetail",
		dbName: dbName
	};
	$.post(host, params, function (data) {
		let table = ``;
		var total = 0;
		var totales = ``;
		$.each(data, function (key, val) {
			if (val.tipoEnvio == '1') {
				totales = val.total;
			} else {
				totales = "0.00";
			}
			total += accounting.unformat(val.total);
			table += `
				<tr>
					<td style="padding-left: 15px">${val.cantidad}</td>
					<td style="padding-left: 15px">${val.descLarga}</td>
					<td style="padding-left: 15px">${val.cantFardos}</td>
					<td style="padding-left: 15px">${totales}</td>
				</tr>
			`;
		});
		$("#bodyTableEnvioRecibo tbody").html(table);
	}, "json").done(function () {
	});
}

function popUpEnvioRecibo() {
	window.open("envioPrintRecibo.html", "", "width=1000,height=800");
}
